VEC___C SEGMENT CODE

EXTRN	CODE(RES_STAR,ADDATDP)
PUBLIC  VEC_CLR,VEC_SET,VEC_GET,VEC_USR,VEC_ARR

CSEG	AT    0000H
	JMP   RES_PRE
	JMP   $+8000H	; 03  EXTI0
	JMP   $+8000H   ; 06  SYS_FNC
	DS    2
	JMP   $+8000H   ; 0B  TIMER0
	JMP   $+8000H   ; 0E
	DS    2
	JMP   $+8000H	; 13  EXTI1
	JMP   $+8000H   ; 16
	DS    2
	JMP   $+8000H   ; 1B  TIMER1
	JMP   $+8000H   ; 1E  V_uL_ADD
	DS    2
	JMP   $+8000H	; 23  SINT
	JMP   $+8000H   ; 26  V_uL_FNC
	DS    2
	JMP   $+8000H   ; 2B  SIIC
	JMP   $+8000H   ; 2E
	DS    2
	JMP   $+8000H	; 33  T2CAP0
	JMP   $+8000H   ; 36
	DS    2
	JMP   $+8000H   ; 3B  T2CAP1
	JMP   $+8000H   ; 3E
	DS    2
	JMP   $+8000H	; 43  T2CAP2
	JMP   $+8000H   ; 46
	DS    2
	JMP   $+8000H   ; 4B  T2CAP3
	JMP   $+8000H   ; 4E
	DS    2
	JMP   $+8000H	; 53  ADCINT
	JMP   $+8000H   ; 56
	DS    2
	JMP   $+8000H   ; 5B  T2CMP0
	JMP   $+8000H   ; 5E
	DS    2
	JMP   $+8000H	; 63  T2CMP1
	JMP   $+8000H   ; 66
	DS    2
	JMP   $+8000H   ; 6B  T2CMP2
	JMP   $+8000H   ; 6E
	DS    2
	JMP   $+8000H	; 73  TIMER2
	JMP   $+8000H   ; 76
	DS    2
	JMP   $+8000H   ; 7B

CSEG	AT    0080H
	JMP   VEC_SET
	JMP   $+8000H   ; 83  S1INT
	JMP   VEC_USR
	DS    2
	JMP   $+8000H   ; 8B
	JMP   VEC_GET

CSEG	AT    009BH
	JMP   $+8000H   ; 9B

XSEG	AT    8000H
VEC_ARR:DS    0A0H	; Prelozene pole vektoru

RSEG    VEC___C

RES_PRE:CLR   EA
	CALL  VEC_CLR
	JMP   RES_STAR

VEC_CLR:MOV   R4,#0
	MOV   DPTR,#0
	CALL  VEC_SET
	MOV   R0,#3
	MOV   R1,#9*2
VEC_CL1:MOV   A,R0
	MOV   R4,A
	MOV   DPTR,#RETI_A
	CALL  VEC_SET
	DJNZ  R1,VEC_CL2
	RET
VEC_CL2:MOV   A,R0
	ADD   A,#3
	MOV   R4,A
	MOV   DPTR,#RET_A
	CALL  VEC_SET
	MOV   A,R0
	ADD   A,#8
	MOV   R0,A
	SJMP  VEC_CL1

RET_A:  RET
RETI_A: RETI

SYS_FNC:RET

VEC_SET:MOV   A,R4
	MOV   R4,DPL
	MOV   R5,DPH
	MOV   DPTR,#VEC_ARR
	CALL  ADDATDP
VEC_USR:MOV   A,#2
	MOV   C,EA
	CLR   EA
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  A,@DPTR
	XCH   A,R5
	MOVX  @DPTR,A
	INC   DPTR
	MOVX  A,@DPTR
	XCH   A,R4
	MOVX  @DPTR,A
	MOV   EA,C
	RET

VEC_GET:MOV   DPL,R4
	MOV   DPH,#HIGH VEC_ARR
	INC   DPTR
	MOVX  A,@DPTR
	MOV   R5,A
	INC   DPTR
	MOVX  A,@DPTR
	MOV   R4,A
	RET

	END